package com.diagbot.facade.data;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.diagbot.dto.data.ColumnZhAndChDTO;
import com.diagbot.entity.StrIllCritically;
import com.diagbot.service.impl.StrIllCriticallyServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.MapUtil;
import com.diagbot.vo.data.AStrIllCriticallyVO;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class AStrIllCriticallyFacade extends StrIllCriticallyServiceImpl {

    @Autowired
    private ColumnFacade columnFacade;
    @Autowired
    private AMedAbnormalInfoFacade aMedAbnormalInfoFacade;

    public void getColumnZhAndCh(){
        List<ColumnZhAndChDTO> list=this.baseMapper.getColumnZhAndCh();
        list.forEach(s->{
            s.setEn(NamingStrategy.underlineToCamel(s.getEn()));
        });

        Map<String, String> columnMap= EntityUtil.makeMapWithKeyValue(list,"ch","en");
        Boolean flag=columnFacade.createColumn(columnMap,"strIllCritically");

        //Map<String, String> map=columnFacade.getColumn("strConsultationNote");
        if(!flag){
            return;
        }
    }

    public void dealData(String columnMap,Map<String, Object> entityMap,Long hospitalId){
        StrIllCritically strIllCritically=new StrIllCritically();
        try {
            AStrIllCriticallyVO strIllCriticallyVO=(AStrIllCriticallyVO) MapUtil.mapToObject(entityMap, AStrIllCriticallyVO.class);
            BeanUtils.copyProperties(strIllCriticallyVO,strIllCritically);
            strIllCritically.setHospitalId(hospitalId);//医院编码
            strIllCritically.setPatientSignDate(DateUtil.parseDateTime(strIllCriticallyVO.getPatientSignDate()));
            strIllCritically.setDoctorSignDate(DateUtil.parseDateTime(strIllCriticallyVO.getDoctorSignDate()));//审核时间
            strIllCritically.setRecordDate(DateUtil.parseDateTime(strIllCriticallyVO.getRecordDate()));//病历日期

            strIllCritically.setWholeData(columnMap);
            //判断数据库中是否存在，不存在insert
            if(isExist(strIllCritically)){
                strIllCritically.setGmtCreate(new Date());//记录创建时间
                this.save(strIllCritically);
            }else{
                strIllCritically.setGmtModified(new Date());//记录修改时间
                this.update(strIllCritically,new QueryWrapper<StrIllCritically>()
                        .eq("rec_id", strIllCritically.getRecId())
                        .eq("hospital_id", strIllCritically.getHospitalId())
                        .eq("behospital_code", strIllCritically.getBehospitalCode()));
            }

        }catch (Exception e){
            log.error(e.getMessage(),e);
            aMedAbnormalInfoFacade.saveAbnormalInfo("病危通知单",strIllCritically.getRecId(), JSON.toJSONString(entityMap),"",e.getMessage());
        }

    }

    public Boolean isExist(StrIllCritically strIllCritically){
        Boolean flag=true;
        int count = this.baseMapper.selectCount(new QueryWrapper<StrIllCritically>()
                .eq("rec_id", strIllCritically.getRecId())
                .eq("hospital_id", strIllCritically.getHospitalId())
                .eq("behospital_code", strIllCritically.getBehospitalCode()));
        if(count>0){
            flag=false;
        }
        return flag;
    }
}
